#include <SoftwareSerial.h>
#define LED         2
#define motor1_2    3
#define motor3_4    5
#define motor5_6    6
#define RXD_PIN     9    // Required for software serial!
#define TXD_PIN     10   // Required for software serial!

#define MIN         50

SoftwareSerial mySerial(TXD_PIN, RXD_PIN);

void setup()  
{
  // Open serial communications and wait for port to open:
  Serial.begin(115200);
  pinMode(LED, OUTPUT);
  pinMode(motor1_2, OUTPUT);
  pinMode(motor3_4, OUTPUT);
  pinMode(motor5_6, OUTPUT);
  
  // set the data rate for the SoftwareSerial port
  mySerial.begin(115200);
}

void loop() // run over and over
{
  int c=0, data_available1=0, data_available2=0, data_available3=0, start1=0, start2=0, start3=0, data=0, start=0, data_available=0, data1=0, data2=0, data3=0;
   while(1) {
   //acquisition de la data
   if ( mySerial.available() ) {
     c = mySerial.read();
     //Serial.print(c);
     
     //bit de start
     if (c==97) {
       start=1;
       data=0;
     }
     //fin de la 1ere valeur, début de la 2eme
     else if (c==98 && start==1) {
       data1=data;
       data=0;
     }
     //fin de la 2eme valeur, début de la 3eme
     else if (c==99 && start==1) {
       data2=data;
       data=0;
     }
     
     //bits de data
     else if (c<=57 && c>=48 && start==1) {
       data=data*10+(c-48);
     }
     
     //bits de stop
     else if ((c==13 && start==1) || (c==10 && start==1) || (c==122 && start==1)) {
       data3=data;
       data=0;
       data_available=1;
       start=0;
     }
   }

   //écriture de la data sur la sortie PWM
   if (data_available==1) {
     analogWrite(motor1_2, data1);
     analogWrite(motor3_4, data2);
     analogWrite(motor5_6, data3);

     Serial.print("a=");
     Serial.println(data1);
     Serial.print("b=");
     Serial.println(data2);
     Serial.print("c=");
     Serial.println(data3);
     
     data_available=0;
     if (data1 > MIN || data2 > MIN || data3 > MIN) {
      digitalWrite(LED, HIGH);
      Serial.println("LED HIGH");
     }
     else {
      digitalWrite(LED, LOW);
      Serial.println("LED LOW");
     }
   } 
 }
}
